<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: linearly_independent_subset_finder_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_5e84fc1d53d6c0d63218f3bf54f21eee.html">svm</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">linearly_independent_subset_finder_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2008  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_LISf_ABSTRACT_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_LISf_ABSTRACT_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../algs.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../serialize.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;kernel_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;{</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160; </div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        <span class="keyword">typename</span> kernel_type</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        &gt;</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="keyword">class </span>linearly_independent_subset_finder</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    {</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::scalar_type <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a>;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type sample_type;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::sample_type type;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> kernel_type::mem_manager_type mem_manager_type;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160; </div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        linearly_independent_subset_finder (</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        );</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        linearly_independent_subset_finder (</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;            <span class="keyword">const</span> kernel_type&amp; kernel_, </div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_dictionary_size_,</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;            <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> min_tolerance = 0.001</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        );</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        <span class="keyword">const</span> kernel_type&amp; get_kernel (</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> max_dictionary_size(</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> minimum_tolerance(</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        <span class="keywordtype">void</span> set_minimum_tolerance (</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;            <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> min_tolerance </div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        );</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;        <span class="keywordtype">void</span> clear_dictionary (</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;        );</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;        <span class="keywordtype">bool</span> add (</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;            <span class="keyword">const</span> sample_type&amp; x</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;        );</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;        <a class="code" href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">scalar_type</a> projection_error (</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="keyword">const</span> sample_type&amp; x</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        <span class="keywordtype">void</span> swap (</div><div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;            linearly_independent_subset_finder&amp; item</div><div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        );</div><div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> size (</div><div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        <span class="keyword">const</span> sample_type&amp; operator[] (</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> index</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        <span class="keyword">const</span> matrix&lt;sample_type,0,1,mem_manager_type&gt; get_dictionary (</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        <span class="keyword">const</span> matrix&lt;scalar_type,0,0,mem_manager_type&gt;&amp; get_kernel_matrix (</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;        <span class="keyword">const</span> matrix&lt;scalar_type,0,0,mem_manager_type&gt;&amp; get_inv_kernel_marix (</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    };</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160; </div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160; </div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        <span class="keyword">typename</span> kernel_type</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        &gt;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <span class="keywordtype">void</span> swap(</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        linearly_independent_subset_finder&lt;kernel_type&gt;&amp; a, </div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        linearly_independent_subset_finder&lt;kernel_type&gt;&amp; b</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    ) { a.swap(b); }</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        <span class="keyword">typename</span> kernel_type</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;        &gt;</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    <span class="keywordtype">void</span> serialize (</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        <span class="keyword">const</span> linearly_independent_subset_finder&lt;kernel_type&gt;&amp; item,</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        std::ostream&amp; out</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    );</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        <span class="keyword">typename</span> kernel_type </div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        &gt;</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        linearly_independent_subset_finder&lt;kernel_type&gt;&amp; item,</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        std::istream&amp; in </div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    );</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        <span class="keyword">typename</span> T</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        &gt;</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <span class="keyword">const</span> matrix_exp mat (</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        <span class="keyword">const</span> linearly_independent_subset_finder&lt;T&gt;&amp; m </div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    );</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160; </div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        <span class="keyword">typename</span> kernel_type,</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        <span class="keyword">typename</span> vector_type,</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keyword">typename</span> rand_type</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        &gt;</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    <span class="keywordtype">void</span> fill_lisf (</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        linearly_independent_subset_finder&lt;kernel_type&gt;&amp; lisf,</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;        <span class="keyword">const</span> vector_type&amp; samples,</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;        rand_type&amp; rnd,</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        <span class="keywordtype">int</span> sampling_size = 2000</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    );</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        <span class="keyword">typename</span> kernel_type,</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        <span class="keyword">typename</span> vector_type</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        &gt;</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    <span class="keywordtype">void</span> fill_lisf (</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;        linearly_independent_subset_finder&lt;kernel_type&gt;&amp; lisf,</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        <span class="keyword">const</span> vector_type&amp; samples</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    );</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160; </div><div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;}</div><div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160; </div><div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;<span class="preprocessor">#endif // DLIB_LISf_ABSTRACT_</span></div><div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1linearly__independent__subset__finder_html_a9a2a2594c9a4349d86615ae65b5e6438"><div class="ttname"><a href="classdlib_1_1linearly__independent__subset__finder.html#a9a2a2594c9a4349d86615ae65b5e6438">dlib::linearly_independent_subset_finder::scalar_type</a></div><div class="ttdeci">kernel_type::scalar_type scalar_type</div><div class="ttdef"><b>Definition:</b> linearly_independent_subset_finder.h:56</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
